;*****WINCALLBACK***************************************************************
WINCB STRUC              ;main callback variable space structure
 ps PAINTSTRUCT {}
WINCB ENDS

 .DATA

 DATA? cxClient,cyClient

 SJTabBegin              ;build search/jump table

 SJNTAB1 LABEL WORD
  SJTabEntry WM_SYSCOMMAND,SYSCOMMAND_WM ;message table entry
  SJTabEntry WM_PAINT,PAINT_WM           ;message table entry
  SJTabEntry WM_SIZE,SIZE_WM             ;message table entry
  SJTabEntry WM_CREATE,CREATE_WM         ;message table entry
  SJTabEntry WM_DESTROY,DESTROY_WM       ;message table entry
 SJATAB1 LABEL WORD
 SJTENT1 EQU (SJATAB1-SJNTAB1)/WORD

 SJTabEnd SJTMIN,\       ;lowest entry value
          SJTMAX,\       ;highest entry value
          SYSCOMMAND_WM  ;address for entry offset

  .CODE
                         ;upon entry, the stack contains the following
                         ;ESP stack pointer -->return address
                         ;                     window handle
                         ;                     message number
                         ;                     wParam
                         ;                     lParam
WINCALLBACK:
 MOV EAX,[ESP+2*DWORD]   ;window message number from stack

 CMP EAX,SJTMAX          ;SJTMAX=highest window msg num with a user handler
 JA DefWindowProcA       ;immediately jump to default handler

 PUSH EDI                ;save EDI
 MOV ECX,SJTENT1         ;number of entries in window message number table
 MOV EDI,@ SJNTAB1       ;window message number table address
 REPNE SCASW             ;search table for message number

 JZ @F
 POP EDI                 ;restore EDI
 JNZ DefWindowProcA      ;message not found--immediate jump to default handler
@@:
                         ;window message number has been found
 RPUSHIT ESI,EBP,EBX     ;save essential windows registers
 MOV ESI,[ESP+5*DWORD]   ;ESI=windows handle
 MOV EBX,[ESP+7*DWORD]   ;EBX=wParam
 MOV EDX,[ESP+8*DWORD]   ;EDX=lParam
 XOR EBP,EBP             ;EBP=0, valuable to PUSH EBP in handler routines
                         ;after the above instructions, the registers and stack
                         ;contain the following useful values:
                         ;ESI=window handle
                         ;EAX=window message number
                         ;EBX=wParam
                         ;EDX=lParam
                         ;EDI=index+4 of window message number table
                         ;EBP=0
                         ;now, ESP stack pointer -->old entry value of ESI
                         ;                          old entry value of EBP
                         ;                          old entry value of EBX
                         ;                          old entry value of EDI
                         ;                          return addr
                         ;                          windows handle
                         ;                          message number
                         ;                          wParam
                         ;                          lParam
 SUB ESP,WINCB           ;make local variable space on stack

 MOVSX ECX,W[SJATAB1-SJNTAB1-WORD+EDI]
 ADD ECX,@ SYSCOMMAND_WM
 JMP ECX

DEFWINRET:               ;return point to default winproc if needed
 ADD ESP,WINCB           ;recover local variable space on stack
 POPIT ESI,EBP,EBX,EDI   ;restore old entry values of essential registers
 JMP DefWindowProcA      ;for default message processing

MAINCBRET:               ;main callback return--welcome home
 ADD ESP,WINCB           ;recover main callback local variable space on stack

DIAGBOXRET:              ;dialog box return if needed
 POPIT ESI,EBP,EBX,EDI   ;restore old entry values of essential registers
 RET 4*DWORD             ;balance stack upon returning to windows

;*****END OF MAIN CALLBACK******************************************************
;_______________________________________________________________________________
PrintDlgProc:            ;PrintDlgProc(hDlg,message,wParam,lParam)

PDPCB STRUC              ;tailor structure to subroutine
            DWORD ?      ;register save
            DWORD ?      ;register save
 return     DWORD ?
ADR3 = $
 hDlg       DWORD ?      ;parameter
 message    DWORD ?      ;parameter
 wParam     DWORD ?      ;parameter
 lParam     DWORD ?      ;parameter
ADR4 = $
PDPCB ENDS

PDP   EQU ESP.PDPCB      ;save some typing

 RPUSHIT ESI,EBP         ;save registers
 XOR EBP,EBP             ;handy zero
 MOV EAX,[PDP.message]   ;EAX=message number
 MOV ESI,[PDP.hDlg]      ;ESI=handle of dialog box

 .IF EAX == WM_INITDIALOG
   INVOKE SetWindowText,ESI,@ szAppName         ;ESI=hDlg
   INVOKE GetSystemMenu,ESI,EBP                 ;EBP=0=FALSE
   INVOKE EnableMenuItem,EAX,SC_CLOSE,MF_GRAYED
   MOV EAX,ESI           ;ESI=EAX=TRUE
   JMP @F
 .ENDIF

 .IF EAX == WM_COMMAND
   MOV [bUserAbort],ESI        ;ESI=TRUE
   INVOKE GetParent,ESI        ;ESI=hDlg
   INVOKE EnableWindow,EAX,ESP ;ESP<>0=TRUE
   INVOKE DestroyWindow,ESI    ;ESI=hDlg
   MOV [hDlgPrint],EBP         ;EBP=0=NULL
   MOV EAX,ESP                 ;EAX=ESI=TRUE
   JMP @F
 .ENDIF

 XOR EAX,EAX           ;EAX=0=FALSE
@@:
 POPIT ESI,EBP         ;restore registers
 RET ADR4-ADR3         ;return and balance stack
;_______________________________________________________________________________
AbortProc:             ;AbortProc(hdcPrn,icode)

AP STRUC               ;tailor structure to subroutine
ADR1 = $
 MSG {}                ;local structure variable
ADR2 = $
        DWORD ?        ;register save
 return DWORD ?        ;return address
ADR3 = $
 hdcPrn DWORD ?        ;parameter
 iCode  DWORD ?        ;parameter
ADR4 = $
AP ENDS

 RPUSHIT EBP           ;save register
 SUB ESP,ADR2-ADR1     ;make room for local variables
 XOR EBP,EBP           ;EBP=0
@@:
 MOV EAX,ESP           ;EAX=ESP=address of MSG structure
 INVOKE PeekMessage,EAX,EBP,EBP,EBP,PM_REMOVE ;EBP=0=NULL

 .IF ([bUserAbort] == EBP) && EAX
   INVOKE IsDialogMessage,hDlgPrint,ESP ;ESP=&msg
   .IF [hDlgPrint] == EBP || !EAX       ;EBP=0
     INVOKE TranslateMessage,ESP ;ESP=&msg
     INVOKE DispatchMessage,ESP  ;ESP=&msg
   .ENDIF
    JMP @B
 .ENDIF

 XOR EAX,EAX       ;EAX=0=FALSE
 CMP [bUserAbort],EBP
 .IF ZERO?
   INC EAX         ;EAX=TRUE
 .ENDIF

 ADD ESP,ADR2-ADR1 ;recover local storage
 POPIT EBP         ;restore register
 RET ADR4-ADR3     ;return and balance stack
;*****END OF MAIN CALLBACK******************************************************
