@        EQU     OFFSET
NUL      EQU     0       ;NULL
NULL     EQU     0       ;NULL
SPACE    EQU     020H    ;space
BS       EQU     08H     ;backspace
TAB      EQU     09H     ;horizontal tab
HT       EQU     09H     ;horizontal tab
LF       EQU     0AH     ;line feed
CR       EQU     0DH     ;carridge return
CRLF     TEXTEQU <CR,LF> ;carridge return, line feed
LFCR     TEXTEQU <LF,CR> ;line feed, carridge return
ESCAPE   EQU     01BH    ;escape
BEL      EQU     07H     ;bell
FALSE    EQU     0
TRUE     EQU     NOT FALSE
MAX32UN  EQU     07FFFFFFFH ;maximum 32-bit unsigned number
Q        EQU     QWORD PTR
D        EQU     <DWORD PTR>
W        EQU     WORD PTR
B        EQU     BYTE PTR
SB       EQU     SBYTE PTR
SD       EQU     SDWORD PTR
SW       EQU     SWORD PTR

.NOLIST

;*******************************************************************************
; @ArgRev :  MACRO FUNCTION                                                    *
;                                                                              *
; Called by: @ArgRev(P1,P2:VARARG)                                             *
;                                                                              *
; Returns :  VARARG list in reverse order                                      *
;-------------------------------------------------------------------------------
@ArgRev MACRO P1,P2:VARARG
 LOCAL TXT
 TXT TEXTEQU <P1>

 FOR ARG,<P2>
  TXT CATSTR <ARG>,<!,>,TXT
 ENDM

 EXITM <TXT>
ENDM
;*******************************************************************************
PUSHIT MACRO P1:VARARG
 FOR arg,<P1>
  PUSH arg
 ENDM
ENDM
;*******************************************************************************
RPUSHIT MACRO P1:VARARG
%PUSHIT @ArgRev(P1)
ENDM
;*******************************************************************************
POPIT MACRO P1:VARARG
  FOR arg,<P1>
   POP arg
  ENDM
ENDM


;*******************************************************************************
;                                                                              ;
;         SJTabBegin MACRO for search/jump table initialization                ;
;                                                                              ;
;*******************************************************************************
SJTabBegin MACRO
 SJT_MIN$ =MAX32UN          ;minimum message number initialization
 SJT_MAX$ =0                ;maximum message number initialization
 SJT_ENC$ =0                ;number/address counter
ENDM

;*******************************************************************************
;                                                                              ;
;            SJTabEntry MACRO for search/jump table entry                      ;
;                                                                              ;
; P1 -> number entry, P2 -> address entry                                      ;                                                                  ;
;                                                                              ;
;*******************************************************************************
SJTabEntry MACRO P1:REQ,P2:REQ
 IF P1 LT SJT_MIN$  ;\
  SJT_MIN$=P1       ; > determine if message number is a minimum
 ENDIF              ;/

 IF P1 GT SJT_MAX$  ;\
  SJT_MAX$=P1       ; > determine if message number is a maximum
 ENDIF              ;/

 WORD P1
 SJT_ENC$=SJT_ENC$+1           ;increment entry number counter
 @CatStr(SJT_A$,%SJT_ENC$)=P2
ENDM

;*******************************************************************************
;                                                                              ;
;           SJTabEnd MACRO for search/jump table termination                   ;
;                                                                              ;
; P1 -> variable for minimum message number                                    ;
; P2 -> variable for maximum message number                                    ;
; P3 -> variable for relative base address                                     ;
; P4 -> variable for number of table entries                                   ;
;                                                                              ;
;*******************************************************************************
SJTabEnd MACRO P1:REQ,P2:REQ,P3:REQ,P4
 LOCAL M1
 M1=0

 REPEAT SJT_ENC$
  M1=M1+1
  WORD @CatStr(SJT_A$,%M1)-P3
 ENDM

 P1 = SJT_MIN$
 P2 = SJT_MAX$

 IFNB <P4>
  P4 = SJT_ENC$
 ENDIF
ENDM
; ------------------------------------------------------------------------------
DATA? MACRO P1:VARARG
 FOR ARG,<P1>
  ARG DD ?
 ENDM
ENDM
;-------------------------------------------------------------------------------
INVOKIT MACRO P1:REQ,P2:VARARG
 IFNB <P2>
  RPUSHIT P2
 ENDIF
 CALL P1
ENDM
;-------------------------------------------------------------------------------
BYTER MACRO P1:VARARG            ;inline code for BYTE string and implicit label
LOCAL L1
 .DATA
L1 BYTE P1
 .CODE
 EXITM <OFFSET L1>
ENDM
;-------------------------------------------------------------------------------
LBYTER MACRO P1,P2:VARARG        ;inline code for BYTE string and explicit label
 .DATA
P1 BYTE P2
 .CODE
 EXITM <OFFSET P1>
ENDM
;-------------------------------------------------------------------------------
BYTIT MACRO P1,P2:VARARG        ;inline code for BYTE string and length variable
 LOCAL L1
 .DATA
 L1 BYTE P2
 P1=$-L1                        ;P1=length of string
 .CODE
 EXITM <OFFSET L1>
ENDM
;*******************************************************************************
